#include "mlp.h"

void blitzInit(std::unique_ptr<NETWORK>& network, const std::vector<std::vector<double>>& sample, const std::vector<std::vector<double>>& desired, size_t mode) {

	const size_t outputCount = desired[0].size();
	std::vector<std::vector<double>> representants(outputCount);

	//vyber reprezentanta pro kazdou tridu
	for (size_t i = 0; i < outputCount; i++) {
		for (size_t j = 0; j < desired.size(); j++) {
			if (desired[j][i] > 0.8) { // == 1
				representants[i] = sample[j];
				break;
			}
		}
	}

	//snizeni vah vsech neuronu na male cislo
	if (mode == 1) {
		for (size_t i = 0; i < network->layers.size(); i++) {
			size_t neurons = network->layers[i].neurons.size();

			LAYER& currLayer = network->layers[i];

			for (size_t j = 0; j < neurons; j++) {

				NEURON& neuron = currLayer.neurons[j];

				for (size_t k = 0; k < neuron.weights.size(); k++) {
					neuron.weights[k] = drand() * 0.1;
				}
			}

		}
	}

	//nastavit vahy pro kazdeho reprezentanta
	for (size_t i = 0; i < outputCount; i++) {

		for (size_t j = 0; j < representants[i].size(); j++) {
			network->layers[0].neurons[i].weights[j] = representants[i][j];
		}

		std::fill(network->layers[network->layers.size() - 1].neurons[i].weights.begin(), network->layers[network->layers.size() - 1].neurons[i].weights.end(), 0.0);
		network->layers[network->layers.size() - 1].neurons[i].weights[i + 1] = 1.0;

	}
}
