#include "mlp.h"

void freelyGrowingInit(std::unique_ptr<NETWORK>& network, const std::vector<std::vector<double>>& sample, const std::vector<std::vector<double>>& desired, size_t mode) {

	//vynulovani vah vsech neuronu
	for (size_t i = 0; i < network->layers.size(); i++) {
		size_t neurons = network->layers[i].neurons.size();
		LAYER& currLayer = network->layers[i];

		for (size_t j = 0; j < neurons; j++) {

			NEURON& neuron = currLayer.neurons[j];
			for (size_t k = 0; k < neuron.weights.size(); k++) {
				neuron.weights[k] = (mode == 3 ? drand() * 0.1 : 0.0);
			}
		}
	}

	const size_t maxNeurons = network->layers[0].neurons.size();
	size_t neuronCounter = 0;

	std::vector<int> neuronClasses(maxNeurons);
	std::vector<int> neuronQuantities(maxNeurons);
	std::fill(neuronClasses.begin(), neuronClasses.end(), -1);
	std::fill(neuronQuantities.begin(), neuronQuantities.end(), 0);

	std::vector<size_t> classesCount(desired[0].size());

	for (size_t i = 0; i < sample.size(); i++) {

		bool assigned = false;

		int clss = -1;
		for (size_t j = 0; j < desired[i].size(); j++) {
			if (desired[i][j] > 0.99) {
				clss = (int)j;
				break;
			}
		}

		if (clss < 0) {
			continue;
		}

		for (size_t j = 0; j < neuronCounter; j++) {
			if (neuronClasses[j] == clss) {

				double tmp = 0;
				for (size_t k = 0; k < sample[i].size(); k++) {
					tmp += std::pow(sample[i][k] - network->layers[0].neurons[j].weights[k], 2.0);
				}

				tmp = std::sqrt(tmp);
				tmp /= (double)sample[i].size();

				if (tmp < 0.1) { // TODO konstanta podobnosti

					for (size_t k = 0; k < sample[i].size(); k++) {
						network->layers[0].neurons[j].weights[k] = ((double)neuronQuantities[j] * network->layers[0].neurons[j].weights[k] + sample[i][k]) / ((double)neuronQuantities[j] + 1);
					}

					neuronQuantities[j]++;
					assigned = true;
				}
			}
		}

		if (assigned) {
			continue;
		}

		NEURON& hiddenNeuron = network->layers[0].neurons[neuronCounter];

		neuronClasses[neuronCounter] = clss;
		neuronQuantities[neuronCounter] = 1;

		for (size_t k = 0; k < sample[i].size(); k++) {
			hiddenNeuron.weights[k] = sample[i][k];
		}

		neuronCounter++;
		if (neuronCounter >= maxNeurons) {
			break;
		}
	}

	if (mode == 1) {
		//
	}
	else if (mode == 2) {

		const double weightIncrement = 0.1;

		double maxWeight = 0.0;

		for (size_t i = 0; i < neuronCounter; i++) {

			NEURON& outNeuron = network->layers[network->layers.size() - 1].neurons[neuronClasses[i]];

			outNeuron.weights[i] += weightIncrement * (double)neuronQuantities[i];
			maxWeight = std::max(maxWeight, outNeuron.weights[i]);
		}

		for (size_t i = 0; i < neuronCounter; i++) {

			NEURON& outNeuron = network->layers[network->layers.size() - 1].neurons[neuronClasses[i]];
			outNeuron.weights[i] = outNeuron.weights[i] / maxWeight;
		}
	}
	else if (mode == 3) {
		//nahodne vahy nahore
	}

}
